	
;---------------------------
;ROUTINE TO PLAY MUSIC
;All you need is to execute CALL PlayMusic somewhere from your other code
;it plays one channel at constant volume
;start of music data is at address with label MusicData
;it can play to 255 notes
;each note is described by 3 numbers - first for length and  following 2 for frequency

; program at start should have:
;CurrentNoteLength set to 0
;CurrentNoteNr set to 0

;---------------------------
PlayMusic
;playing new note or already begun note?

	LD A,(CurrentNoteLength)
	OR A
	JR NZ,PlayNote ; note already begun


SetNewNote
	LD HL,CurrentNoteNr
	LD A,(HL)
	INC A
	CP 57 ;compare with melody length,if A=length of melody+1 => a=1 (loop the melody)
	JR NZ, SetNewNote2
	LD A,1

SetNewNote2
	LD (HL),A ;set number of note
		
;set length of note
	
	;calculate address where length is stored
	LD B,A
	LD HL,MusicData-3
	LD DE,3
SetNewNote3
	ADD HL,DE
	DJNZ SetNewNote3
	
	LD A,(HL)
	LD (CurrentNoteLength),A; store new note length
	
	INC HL; go to note frequencies (they are just after length)
	LD (CurrentNoteFreqAddr),HL; store address of note frequencies
	
;--------	
PlayNote
	LD HL,(CurrentNoteFreqAddr); address of frequences in hl
	CALL OneMusicNote; plays (in one interrupt) the note with given frequencies
	LD HL, CurrentNoteLength
	DEC (HL); decrease time of note yet to be played
	RET

CurrentNoteFreqAddr
	.WORD 0
;CurrentNoteNr
	.BYTE 0	
;CurrentNoteLength
	.BYTE 0	

;----------


OneMusicNote
;should be called with HL indicating to address of frequencies of note		
	LD DE, MusicRegisters
	LD A,4
		
OneMusicNote2
	PUSH AF
	;set register
	LD BC,65533 ;port address needed to choose register
	LD A,(DE) ;register number
 	OUT (C),A ;register chosen
 	INC DE; next register
 	
 	;set value
	POP AF
	PUSH AF
 	LD BC,49149 ;port address needed to send number to the register
 	 	
 	;there are 4 numbers to be sent to registers in order to play one note:
 	;first 2 numbers for note frequency, then 1 for volume and last one for choosing channel
 	;the 2 numbers for frequency are read from data beginning with MusicNotes
 	;other numbers are constant, so if loop counter indicates them to be given a constant value is taken
 	
  	CP 2 ; time for volume?
 	JR Z,SetVolume
 	
 	CP 1 ; time for channel unlocking?
 	JR Z, SetChannel
 	
SetFrequency
 	LD A,(HL)
  	INC HL; next frequency data value
 	JR OneMusicNote3
 
SetVolume
	LD A,10 ; volume (0-15)
  	JR OneMusicNote3
SetChannel
 	LD A,62 ;select channel A
  	JR OneMusicNote3
 	
 
OneMusicNote3	
 	OUT (C),A ;sent number to register
 	POP AF
 	DEC A
 	JR NZ, OneMusicNote2	;another number to another register
  	RET

MusicRegisters
	.BYTE 0,1,8,7 

;------ 
 	
MusicData
	.BYTE   6,46,2, 6,162,1, 6,162,1, 6,116,1, 6,116,1, 18,75,1, 6,46,2, 6,162,1, 6,162,1, 6,116,1, 6,116,1, 18,162,1 ;12
	.BYTE 6,232,2, 6,46,2, 6,46,2, 6,241,1, 6,162,1, 12,186,1, 6,46,2, 6,162,1, 12,186,1, 6,46,2 ;10
	.BYTE 6,232,2, 6,46,2, 6,46,2, 6,241,1, 6,241,1, 24,46,2 ; 6
	.BYTE 6,232,2, 6,46,2, 6,46,2, 6,241,1, 6,241,1, 6,186,1, 6,162,1, 12,116,1;8
	.BYTE 6,23,1, 6,39,1, 6,116,1, 6,75,1, 6,162,1, 24,116,1 ;6
	.BYTE 6,116,1, 6,186,1, 6,241,1, 6,46,2, 6,186,1, 6,241,1, 6,46,2, 6,151,2;8
	.BYTE 6,46,2,  6,46,2,  6,46,2,  6,232,2, 6,68,3, 12,117,3  ;6
	    
	