


;--------------
MoveRight
;rotates bikes in buffer one pixel right	
	;HL contains buffer adress
	PUSH HL
	LD D,2
	CALL MoveRight2
	POP HL
	LD A,L
	ADD A,128
	LD L,A
	LD D,2
	CALL MoveRight2
	RET
			
MoveRight2
;hl- address of top char line, d-number of char lines
			
	PUSH HL	;rotate one char line,8 byte lines
	LD B,8
	
MoveRight3		
	PUSH HL
	;rotate most right byte
	LD A,L
	ADD A,31
	LD L,A
	LD A,(HL)
	RRA ; rotates most right byte, not is screen but just in register
		;that sets carry flag appropriately to be used by most left byte	
	POP HL
	PUSH HL
	
	;rotate one byte line
		RR (HL);rotate one byte
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;10
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;20
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L
		RR (HL)
		INC L;32
;-------	
	POP HL
	INC H
	DJNZ MoveRight3	
	;go to next char line
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	DEC D
	JR NZ,MoveRight2		
	RET

	
;--------------------------
MoveLeft
	;moves bikes one pixel left in backbuffer
	;HL contains address of backbuffer
	PUSH HL
	LD D,2
	CALL MoveLeft2	
	POP HL
	LD A,L
	ADD A,128
	LD L,A
	
	LD D,2
	CALL MoveLeft2	
	RET	
		
MoveLeft2
	PUSH HL	;rotate one char line,8lines
	LD B,8
	
;----ONE LINE-----		
MoveLeft3
	
	;rotate most left byte
	PUSH HL
	LD A,L
	SUB 31
	LD L,A;go to most left byte
	LD A,(HL)
	RLA ; rotates most left byte, not is screen but just in register
		;that sets carry flag appropraitely to be used by most right byte	
	POP HL
	PUSH HL
	
	;rotate one byte line
	RL (HL)
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L		
	RL (HL)
	DEC L	;10
		
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L ;20
		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L;32

;-------	
	POP HL
	INC H
	DJNZ	MoveLeft3	
	;next char line
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	DEC D
	JR NZ,MoveLeft2	
	
	RET
;--------PLAYER CONTROL-------
PlayerControl
	LD BC,31; read joystick
	IN A,(C)
	LD D,A

	AND 00001111b ;check if any keys were pressed
	OR A; 0 means no keys were pressed
	JR NZ,PlayerControl1
	
	XOR A
	LD (WalkStatus),A; flag meaning that player is standing	
	RET
;----------	
PlayerControl1	
	LD HL,(playerXY)
	BIT 0,D;check going left
	JR NZ,PlayerControl2
	
CheckLeftEdges1	
		LD A,L
		CP 8 ;is  player in top of screen and may walk into car?
		JR NC, CheckLeftEdges2	; no he isn't
		LD A,H ;yes he is
		CP 20
		JR Z,PlayerControl3 ; tried to walk into car 
			
CheckLeftEdges2	
		LD A,L
		CP 15;is  player in bottom of screen and may walk into car?
		JR C,CheckLeftEdgesEnd	; no he isn't
		LD A,H ;yes he is
		CP 25
		JR Z,PlayerControl3 ; tried to walk into car 
CheckLeftEdgesEnd	
	
		LD A,H
		OR A ; left edge of screen reached
		JR Z,PlayerControl3
	
	DEC H; go left

;---------------
PlayerControl2:
	BIT 1,D;check going right
	JR NZ,PlayerControl3

CheckRightEdges1	
		LD A,L
		CP 8 ;is  player in top of screen and may walk into car?
		JR NC, CheckRightEdges2	; no he isn't
		LD A,H ;yes he is
		CP 9
		JR Z,PlayerControl3 ; tried to walk into car 
			
CheckRightEdges2	
		LD A,L
		CP 15;is  player in bottom of screen and may walk into car?
		JR C,CheckRightEdgesEnd	; no he isn't
		LD A,H ;yes he is
		CP 4
		JR Z,PlayerControl3 ; tried to walk into car 	
CheckRightEdgesEnd
		
		LD A,H
		CP 30 ; right edge of screen reached
		RET Z
	
	INC H; go right
;---------------	
PlayerControl3:
	BIT 2,D;check going down
	JR Z,PlayerControl4

CheckDownEdges1
		LD A,L
		CP 14; is player in such line that he may try to walk into car?	
		JR NZ,CheckDownEdgesEnd	
	
		LD A,H
		CP 5
		JR C,CheckDownEdgesEnd ;player position	left of cars=may walk down
		CP 25
		JR NC,CheckDownEdgesEnd ;player position right of cars=may walk down
		JR PlayerControl4 ;else = tried to bump into car
CheckDownEdgesEnd	

	LD A,L
	CP 16 ;bottom of playing area reached?
	JR NZ, PlayerGoDown
	
	;enter bank or hotel
	LD A,H
	CP 15 ;left or right side of screen? 
	JR NC,GoHotel
GoBank
	LD A,6
	LD (moneyMeter),A ;collect money from bank
	CALL SetSpecialEvent
	EXX
	CALL DrawCounters
	EXX
	JR PlayerControl4
	
GoHotel
	EXX
	LD HL,moneyMeter
	DEC (HL)
	DEC (HL) ;pay for hotel
	INC HL; go to power
	LD A,6
	LD (HL),A ;rest = restore power
	CALL SetSpecialEvent
	CALL DrawCounters
	EXX
	JR PlayerControl4
PlayerGoDown	
	INC L; go down
;---------------------
PlayerControl4
	BIT 3,D;check going up
	JR Z,PlayerControl5
	
CheckUpEdges1
		LD A,L
		CP 8; is player in such line that he may try to walk into car?	
		JR NZ,CheckUpEdgesEnd	
	
		LD A,H
		CP 10
		JR C,CheckUpEdgesEnd ;player position	left of cars=may walk down
		CP 20
		JR NC,CheckUpEdgesEnd ;player position right of cars=may walk down
		JR PlayerControl5 ;else = tried to bump into car
CheckUpEdgesEnd	
	
	LD A,L
	CP 6 ;top of playing area reached?
	JR NZ, PlayerGoUp ;no
	
CheckSex
	LD A,H ;check if player enters sex
	CP 22 ;door position
	JR NZ,CheckGanja
	
	;enter sex, make red curtains
	EXX
	LD BC,4*256+3
	LD DE,RedBlank
	LD HL,16384+89
	CALL TileBlock
	
	LD HL,sexCount
	INC (HL) ;statistics how many times player had sex
	LD HL,(score)
	LD DE,5
	ADD HL,DE
	LD (score),HL
	
	LD HL,sexMeter
	CALL RestoreCounter
	CALL DrawCounters
	EXX
	;set player entered sex
	LD A,2
	CALL SetSpecialEvent
		
CheckGanja	
	CP 1;door position
	JR NZ,PlayerControl5
	
	EXX
	LD HL,ganjaCount 
	INC (HL)
	LD HL,(score)
	LD DE,5
	ADD HL,DE
	LD (score),HL
	;restore ganja meter
	LD HL,ganjaMeter
	CALL RestoreCounter
	
	CALL DrawCounters
	EXX
	
	LD A,1;set player entered ganja bar
	CALL SetSpecialEvent
	
	JR PlayerControl5
	
PlayerGoUp	
	DEC L; go up
	
;----------
PlayerControl5
			
	LD (playerXY),HL
	PUSH HL
	POP BC; xy coordinates in bc
	
	CALL XYtoHL
	LD A,1; flag meaning that player is walking
	LD (WalkStatus),A
	RET
WalkStatus .BYTE 0


;--------------------------------------
XYtoHL
	;converts coordinates
	;needs bc:b-x(0-31;0 is left collumn),c-y(0-23;0 is top line)
	LD A,C
	AND 11111000b ;extract 0,8,or 16
	OR 01000000b; add 64-->gives 64,72,80
	LD H,A
	LD A,C
	AND 00000111b;extract 0-7
	RLA
	RLA
	RLA
	RLA
	RLA;multiply by 32, give 0,32,64,...,224
	ADD A,B
	LD L,A
	LD (playerHL),HL
	RET	
;------------------------------------------------
SetSpecialEvent
	LD (playerStatus),A ;which place player entered
	LD A,70
	LD (specialEventTime),A ;set time
	RET
;--------------
	
SpecialEvents
	LD A,(playerStatus)
	OR A
	RET Z
	CP 1
	JR Z,Ganja
	CP 2
	JR Z, Sex
	
	CALL SpecialEventsEnd ;check if event has ended	
	RET	
;------

Ganja
	;draw smoking player
	LD DE,Smoke1
	LD A,(gameCycle)
	BIT 3,A ;flip frames
	JR Z,Ganja2	
	LD DE,Smoke2
Ganja2	
	LD HL,16384+3*32+6
	CALL DrawTile
	CALL SpecialEventsEnd
	RET

	
;-------	
Sex	
	;draw couple
	LD DE,Couple1
	LD A,(gameCycle)
	BIT 3,A ;flip frames
	JR Z,Sex2
	LD DE,Couple2
Sex2	
	LD HL,16384+3*32+26
	CALL DrawTile
	CALL SpecialEventsEnd
	RET
	

	
;-----------
SpecialEventsEnd
	LD HL,specialEventTime
	DEC (HL) ;decrease time left for this event
	RET NZ ;did timer reach 0?
	
	;end of event
	XOR A
	LD (playerStatus),A ; player in the street again
	
	;Restore windows
	LD BC,4*256+3
	LD DE,Blank
	PUSH DE
	PUSH BC
	LD HL,16384+69
	CALL TileBlock
	POP BC
	POP DE
	LD HL,16384+89
	CALL TileBlock
	LD DE,Girl
	LD HL,16384+122
	CALL DrawTile
	
	RET
;---------------------
CheckCollision
; the idea behind checking collision of player and bike is
;to check the area occupied by player sprite in bike buffer
;(bike buffer contains only bikes, the player sprite is drawn
; directly into screen), so if player area in buffer contains
;any bytes different than 0 that means a bike is present in this area
;thus meansing collision

	LD HL,(playerHL)
	CALL CheckCollision2 ;upper left char	
	INC L
	CALL CheckCollision2 ;upper right char		
	LD A,L
	ADD A,32 ;go to bottom line of sprite
	LD L,A
	JR NC,CheckCollision1
	LD A,H ;change segment if necessary
	ADD A,8
	LD H,A
CheckCollision1
	CALL CheckCollision2 ;lower right char	
	DEC L
	CALL CheckCollision2 ;lower left char	
	;checking collision is finished
	RET
CheckCollision2	
	LD A,H
	CP 72 ;is this part of player in bike area=middle segment of screen?
	CALL Z,CheckCollisionChar	
	
	RET
CheckCollisionChar	
	LD D,$70 ;D loaded with bike buffer high byte address
	LD E,L ; E loaded with player position; so now DE contains position
			;of  one char of player in bike buffer
	LD B,8	;check 8 bytes of char

CheckCollisionChar2	
	LD A,(DE)
	OR A
	JR NZ,CollisionDetected ;hit by bike
	INC D
	DJNZ CheckCollisionChar2	
	RET
	
CollisionDetected
	LD A,13 ;instead of 13 there could be used any number <>0 to indicate collision
	LD (gameOverStatus),A
	RET
			