			DEVICE ZXSPECTRUM48
roadBuffer1 EQU  $7000
roadBuffer2 EQU  $8000


roadInScreen EQU $4800
stateCounter EQU 64000 ;plyer stands or walks
playerXY	 EQU 64001			
playerHL	 EQU 64003
gameCycle	 EQU 64005

specialEventTime	EQU 64007

ganjaMeter			EQU 64008
sexMeter			EQU 64009
moneyMeter			EQU 64010
powerMeter			EQU 64011

playerStatus		EQU 64012 ; 0-street, 1-ganja,2-sex,6-bank,hotel
gameOverStatus 		EQU 64013
ganjaCount			EQU 64014
sexCount			EQU 64015
score				EQU 64016
CurrentNoteNr		EQU 64018
CurrentNoteLength	EQU 64019
		
	ORG $A000
StartGame
	EI
	LD SP,65000
		
StartGame2	
;set game parameters
;set counters to 6 = max	
	LD A,6
	LD HL,ganjaMeter
	LD B,4
SetInitialMeters1
	LD (HL),A
	INC HL
	DJNZ SetInitialMeters1
;set some parameters to 0
;(player status=in street, game over=not happened, ganjacount,sexcount,score)
	XOR A
	LD HL,playerStatus
	LD B,8
SetInitialMeters2
	LD (HL),A
	INC HL
	DJNZ SetInitialMeters2
	
	
	
	LD HL,26*256+16
	LD (playerXY),HL
	PUSH HL
	POP BC
	CALL XYtoHL ;sets player position
	
	CALL StartScreen ;menu screen
		
	CALL DrawScreen ; game screen
	CALL DrawMenu
	
;--------------		
MainGameLoop:
		LD A,(gameOverStatus) ;check if game over happened
		OR A
		JP NZ,GameOver

		LD HL,gameCycle
		INC (HL)
		
		LD A,(HL)
		AND 01111111b
		OR A
		JP Z, DecreaseCounters ;decrease sex nad ganja meters when cycle is 0
		
MoveBikes					
		;move bikes (first animation frame) in buffer1
		LD HL,roadBuffer1
		CALL MoveRight
		LD HL,roadBuffer1+64+31
		CALL MoveLeft
		
		
		;move bikes (second animation frame) in buffer2
		LD HL,roadBuffer2
		CALL MoveRight
		LD HL,roadBuffer2+64+31
		CALL MoveLeft
		
		;decide which buffer should be copied to screen
		LD HL,stateCounter
		INC (HL)
		LD A,(HL)
		BIT 2,A
		JR Z,ChooseBuffer2
				
ChooseBuffer1:
		LD HL,roadBuffer1
		JR BufferChosen
ChooseBuffer2:
		LD HL,roadBuffer2		
BufferChosen:
		
	LD DE,roadInScreen
	LD BC,2048
	EXX
	
	HALT
	LD C,8 ;8 char lines
	
CopyBuffer:
	LD B,16
	
	
CopyBuffer2:	
	EXX ;one char line
	LDI ;LD (HL) TO (DE), HL++,DE++,BC--
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	EXX
	DJNZ CopyBuffer2				
	
	;restore player sprite if deleted by bikes
	PUSH BC
	CALL DrawPlayer
	POP BC
	
	DEC C
	JR NZ, CopyBuffer
	
	EXX	
	
	CALL SpecialEvents
	CALL ClearPlayer ; deletes player old position and draws player at new position
	
	CALL CheckCollision
	
	CALL PlayMusic
	
	JP MainGameLoop
	
;---------------------
ClearPlayer
	;clear player
	LD HL,(playerHL)
	LD BC,2*256+2
	LD DE,Blank
	CALL TileBlock
	
	LD A,(playerStatus)
	OR A
	RET NZ; don't control player if he is e.g in bar

	;change position at certain game cycles
	LD A,(gameCycle)
	AND 00000011b
	OR A
	CALL Z,PlayerControl

DrawPlayer	
	;draw player
	LD A,(playerStatus)
	OR A
	RET NZ; don't draw player if he is e.g in bar
	
	LD HL,(playerHL)
	
	LD A,(WalkStatus) ; in PlayerControl routine just before E was set to 1 or 0
	OR A
	JR Z, DrawPlayerStand ;determines which sprite to be used walking or standing

DrawPlayerWalk
	LD DE,PlayerWalk1
	LD A,(stateCounter)
	BIT 3,A
	JR Z,DrawPlayerEnd
	LD DE,PlayerWalk2
	JR DrawPlayerEnd
	
DrawPlayerStand
	LD DE,PlayerStand1
	LD A,(stateCounter)
	BIT 3,A
	JR Z,DrawPlayerEnd
	LD DE,PlayerStand2
			
DrawPlayerEnd:	
	CALL DrawTile
	RET
	

;------------------------



		
;---------
;Graphic data
	INCLUDE <amst_graph.asm>
;Game routines	
	INCLUDE <amst_routines.asm>
;Game music	
	INCLUDE <amst_music.asm>
;---------
	
			SAVESNA "Amsterdam.sna",StartGame
